#!/opt/lampp/bin/perl
###############################################################################
# Author: Francis Turner	Date: 9 August 2005
# (c) Francis Turner 2005
# Version 1.0
#
# Author contact information at http://www.di2.nu/content.htm
# Latest versions etc. of this files at http://www.di2.nu/software/index.htm
#
# These files are released under the Creative Commons Attribution-NonCommercial
# ShareAlike License. http://creativecommons.org/licenses/by-nc-sa/2.5/
#
# This script is used to run a daemon that controls realplayer
# The basic assumptions are that
# 1) realplayer in the path.
# 2) you have a webserver running with perl & CGI enabled 
# 3) you music is based on a single root, is arranged by Artist/Album
#    under that and is of types mp3, rmj or m4a (lower case)
# the whole of (2) other is optional if you write some other controller.
# Effectively no checking of permissions or authenication is performed. You may wish to 
# change this if your webserver is publically accessable.
# Under no circumstances will the author accept any liablity for data loss
# caused by the execution of this program. 
#
# Version 1.0	Initial public release 
###############################################################################

use CGI ':standard';
use CGI::Carp qw/fatalsToBrowser/;
use IO::Socket;

my $PORT = 9000;
my $musicdir = '/opt/My Music';

# Query the daemon to see what is happening and what is queued up
# and put it on the web page
sub get_status {
    my $remote = IO::Socket::INET->new( Proto     => "tcp",
					 PeerAddr  => 'localhost',
					 PeerPort  => $PORT,
				        );
    unless ($remote) { die "cannot connect to player daemon" }
    $remote->autoflush(1);
    print $remote "STATUS$/";
    my $statusline = <$remote>;
    close $remote;
    # print $statusline;
    my @tracks = split ('@@', $statusline);
    print h3("Current status: ".(shift @tracks));
    if ($#tracks>0) {
        print $#tracks--," track(s) in the queue",
         (($#tracks<0)?"":ul(li([map {substr($_,0,rindex($_,'.'))} @tracks])));  
    }
}

#load the available tracks from the file
sub get_tracks {
    local $_ = $/;
    local $/;
    open (FILE, "<$musicdir/tracks.txt") or die "No info";
    my $tracks = <FILE>;
    close (FILE);
    $/=$_;
    return (split($/,$tracks));
}

#if there was a POST action then we need to do something so do it
if (param()) {
    my $remote = IO::Socket::INET->new( Proto     => "tcp",
					 PeerAddr  => 'localhost',
					 PeerPort  => $PORT,
				        );


    unless ($remote) { die "cannot connect to player daemon" }
    $remote->autoflush(1);
    if (param('tracks')) {
        print $remote $_.$/ foreach (param('tracks'));
    }


    print $remote 'QUIT'.$/.$/ if (param('action') eq 'Stop Daemon');
    print $remote 'RELOAD'.$/.$/ if (param('action') eq 'Reload Daemon');
    print $remote 'CLEAR'.$/ if (param('action') eq 'Clear Playlist');
    print $remote 'SEARCH'.$/ if (param('action') eq 'Rescan Music');

    close $remote;
    # sleep 10 sec to let server finish music scanning so that 
    # we will use the updated track list
    sleep 10 if (param('action') eq 'Rescan Music'); 
}

# note need to this after the param check incase the command was to rescan
my @tracks = get_tracks();

#start producing page
print header;
#simple security check just in case system is accidentally open to outside world
unless (($ENV{'REMOTE_ADDR'} eq '127.0.0.1')||($ENV{'REMOTE_ADDR'}=~/10.0.1.2/)) {
    print start_html('Access Denied'),h1('Access Denied'),end_html;
    exit;
}
print start_html(-title=>'Francis\' Realplayer Controller',
   # refresh set to 60 secs by default comment out if it annoys
  -head=>meta({-http_equiv => 'Refresh',-content    => '60'}),
   # comment out stylesheet or change it if required
  -STYLE=>'/images/player.css' ),
h1('Realplayer Controller');
#output current daemon status
get_status();
print hr;
#the following comented out bit may be of interest for a more advanced
#track selection method
#my $last_cd;
#my %tracksinnameonly;
#for (@tracks) {#
#    my $slash = rindex($_,'/');
#    my $this_cd = substr($_,0,$slash); $this_cd=~s'/'<br>';
#    my $track = substr($_,$slash+1);
#print "$this_cd ne $last_cd $slash.$_".br;
#    print (($last_cd?'</ul></p>':'').'<p>'.$this_cd.'<ul>') if ($this_cd ne $last_cd);
#    $tracksinnameonly{$track}=substr($track,0,rindex($track,'.'));
#    print li($tracksinnameonly{$track});
#    $last_cd = $this_cd;
#}
print #'</ul></p>'.
# now create multiselect list of tracks
 start_form.scrolling_list(-name=>'tracks',-values=>\@tracks,
		   -labels=>{map {($_,substr($_,0,rindex($_,'.')))} @tracks},
                   -size=>20,-multiple=>'true').
# create the action buttons and end the page
p(submit('action','Add to Playlist').' '.
 submit('action','Clear Playlist').' '.
 button(-name=>'jsaction',-value=>'Current Status',
        -onClick=>(param()?'location.replace("'.url.'")':'location.reload(true)'))).hr.
'Only use these if you know what you are doing'.
p(submit('action','Stop Daemon').' '.
 submit('action','Reload Daemon').' '.
 submit('action','Rescan Music')),end_form.end_html;

